/*
    iprig - ham radio via internet
    Copyright (C) 2007 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#include "header.h"

struct rcitem cfg = { &cfg, &cfg };


int read_rc_file(char *filename){
    FILE *f;
    char s[1024], *c, *ss;
    int len;
    struct rcitem *rci, *rcj;

    f = fopen(filename, "rt");
    if (!f) return -1;

    while (fgets(s, 1000, f) != NULL){
        len = strlen(s);
        if (len > 0 && s[len - 1] == '\n'){
            s[len - 1] = '\0';
            len--;
        }
        if (len > 0 && s[len - 1] == '\r'){ 
            s[len - 1] = '\0'; /* probably unreachable, fgets() should strip \r */
            len--;
        }

		for (ss=s; *ss==' ' || *ss=='\t'; ss++); 
	    dbg("s='%s', ss='%s'\n", s, ss);
		
        c = index(ss, '#');
		if (c) *c='\0';

        c = index(ss, ' ');
        if (!c) continue;
		if (c==ss) continue;

        rci = NULL;
        foreach(rcj, cfg){
            if (strlen(rcj->key) != c - ss) continue;
            if (strncmp(ss, rcj->key, c - ss) == 0) {
                rci = rcj;
                break;
            }
        }

        if (!rci){
            rci = mem_alloc(sizeof(struct rcitem));
            rci->key = strndup(ss, c - ss);
            add_to_list(cfg, rci);
        }else{
            mem_free(rci->value);
        }
        rci->value = strdup(c + 1);
    }
    fclose(f);    
    
    return 0;
}

int read_rc_files(void){
    char *home, *c;

    read_rc_file("/etc/iprig");

    home = getenv("HOME");
    if (!home) return 0;
    c = mem_alloc(strlen(home) + 10);
    strcpy(c, home);
    strcat(c, "/.iprig");
    read_rc_file(c);
    mem_free(c);
    return 0;
}

char *rc_getopt(char *key){
    struct rcitem *rci;

    foreach(rci, cfg){
        if (strcmp(key, rci->key) != 0) continue;
        return rci->value;
    }
    return NULL;
}

void rc_info(){
    struct rcitem *rci;

    printf("\nrc_info:\n");
    foreach(rci, cfg){
        printf("key='%s'\tvalue='%s'\n", rci->key, rci->value);
    }
}



