/*
    iprig - ham radio via internet
    Copyright (C) 2007 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#include "speakfree.h"
#include "header.h"

int sock = -1;

int init_udp(void){
	int on;
	char errbuf[1024];
	struct sockaddr_in sin;

    sock = -1;

    sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if (sock < 0){
        error("Can't create socket for udp - %s\n", STRERR(errno));
		return -1;
	}

#ifndef __CYGWIN__    
    on=1;
    if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))){
        error("Can't set SO_REUSEADDR - %s\n", STRERR(errno));
        goto x;
    }
#endif 
    
    if (fcntl(sock, F_SETFL, O_NONBLOCK)){
        error("Can't set O_NONBLOCK - %s\n", STRERR(errno));
        goto x;
    }

	/* socket must bind for packet receiving, not for sending */
	memset(&sin, 0, sizeof(struct sockaddr_in));
	sin.sin_family = AF_INET;
	sin.sin_port = htons(Internet_Port);
	sin.sin_addr.s_addr = INADDR_ANY;
    if (bind(sock, (struct sockaddr *)&sin, sizeof(sin))){
		error("Can't bind TCP port %d - %s\n", Internet_Port, STRERR(errno)); 
		goto x;
	}

    return 0;
x:;
    close(sock);
    sock = -1;
    return 0;
}


int free_udp(void){
    close(sock);
    sock = -1;
    return 0;
}

int udp_keepalive(struct conn *conn){
	mike_keepalive(conn);
    return 0;
}
