/*
    iprig - ham radio via internet
    Copyright (C) 2007 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include "zstring.h"
#include "header.h"

char *zconcatesc(char *s1, ...){
    va_list l;
    size_t len;
    char *buf, *d;
    char *s, *c;

    va_start(l, s1);
    s = s1;
    len = 0;
    do {
        if (s != s1) len++;
        for (c = s; *c != '\0'; c++){
            switch(*c){
                case ';':
                case '\\':
                case '\r':
                case '\n':
                    len += 2;
                    break;
                default:
                    len++;
                    break;
            }
        }
    }while ((s = va_arg(l, char *)) != NULL);
    va_end(l);
    len++;

    buf = mem_alloc(len + sizeof(int));
    /*buf+=sizeof(int);*/
    d = buf;

    va_start(l, s1);
    s = s1;
    len = 0;
    do {
        if (s != s1) *d++ = ';';
        for (c = s; *c != '\0'; c++){
            switch(*c){
                case ';':
                    *d++ = '\\';
                    *d++ = ';';
                    break;
                case '\\':
                    *d++ = '\\';
                    *d++ = '\\';
                    break;
                case '\r':
                    *d++ = '\\';
                    *d++ = 'r';
                    break;
                case '\n':
                    *d++ = '\\';
                    *d++ = 'n';
                    break;
                default:
                    *d++ = *c;
                    break;
            }
        }
    }while ((s = va_arg(l, char *)) != NULL);
    va_end(l);
    *d = '\0';
    
    return buf;
}

zchar *zstrdup(const char *str){
    int len;
    zchar *buf;

    len = strlen(str);
    buf = mem_alloc(len + 1 + sizeof(int));
    memcpy(buf + sizeof(int), str, len + 1);
    return buf + sizeof(int);
}

char *ztokenize(zchar *zstr, int first){
    int backslash=0;
    int i;
    char c, *d, *buf;
    int *tokenpos, len;

    tokenpos = (int *)zstr;
    tokenpos--;

    if (first) *tokenpos=0;
    len = strlen(zstr + *tokenpos) + *tokenpos;
    if (*tokenpos > len) return NULL;
    if (*tokenpos < 0) return NULL;
    buf=d=zstr+*tokenpos;

    for (i = *tokenpos; i < len; i++){
        c = zstr[i];
        if (backslash){
            backslash = 0;
            switch(c){
                case '\\':
                case ';':
                    break;
                case 'r':
                    c = '\r';
                    break;
                case 'n':
                    c = '\n';
                    break;
                default: /* error */
                    fprintf(stderr, "bad escape \\%c\n", c);
                    break;
            }
        }else{
            switch (c){
                case '\\':
                    backslash = 1;
                    continue;
                case ';':
                    *tokenpos = i + 1;
                    *d='\0';
                    return buf;
                default:
                    break;
            }
        }
        *d++ = c;
    }
    *tokenpos = -1;
    *d='\0';
    return buf;
}

void zfree(zchar *zstr){
    int *pint;

    pint = (int *)zstr;
    pint--;
    mem_free(pint);
}

#if 0
int main(){
    char *c;
    zchar *z;
    int i;

    c = zconcatesc("aa", ";", "", NULL);
    printf("c='%s'\n", c);
    z = zstrdup(c);
    printf("z='%s'\n", z);

    i = 0;
    for (c = ztokenize(z, 1); c != NULL; c = ztokenize(z, 0)){
        printf("%d='%s'\n", i, c);
        i++;
    }
    zfree(z);
    return 0;
}
#endif
